utility JuicedMeshScript "Juiced 2020 v1.2" width:160 height:466
(
	global VisibleDistance
	global InvisibleDistance
	GroupBox grp1 "Juiced Mesh Importer" pos:[0,0] width:160 height:120
	checkbox chk1 "Index Objects" pos:[8,16] width:144 height:16 enabled:true checked:true
	checkbox chk13 "Clear Scene" pos:[8,40] width:128 height:15 checked:true
	checkbox chk14 "Delete Duplicate TriFaces" pos:[8,65] width:145 height:15 checked:true
	button btn2 "Import Pc" pos:[40,90] width:80 height:24
	
	GroupBox grp2 "Juiced Mesh Exporter" pos:[0,120] width:160 height:390
	button btn27 "Add Selected Objects" pos:[8,137] width:144 height:24
	listbox lbx1 "Objects To Export:" pos:[8,170] width:144 height:6
	label lbl32 "Note: Objects must still be selected when exporting" pos:[8,273] width:144 height:32
	dropdownList ddl1 "Select LOD Level" pos:[8,305] width:144 height:40
	checkbox chk3 "Chassis" pos:[8,353] width:112 height:16 enabled:true checked:false
	dropdownList ddl2 "Shadow/Neon Width" pos:[8,375] width:144 height:40 enabled:false
	dropdownList ddl3 "Shadow/Neon Length" pos:[8,425] width:144 height:40 enabled:false

	button btn6 "Export" pos:[40,475] width:80 height:24
	GroupBox grp5 "About:" pos:[0,515] width:160 height:100
	label lbl3 "Juiced Mesh Import/Export Script Created By Martin_sw" pos:[8,535] width:144 height:32
	label lbl4 "Additional Scripting By Carl 'SxnnyB' Burns -Nov 2020" pos:[8,575] width:144 height:32
	
	--Original Juiced Import Script
	--Version 0.2
	--Made By: Martin_sw
	--
	--Juiced Import Script
	--Version 1.0 - 1.3
	--Made By: Carl 'SxynnyB' Burns
	--
	--Juiced Xbox Import Script
	--Version 1.0
	--Made By: Carl 'SxynnyB' Burns
	--
	--Juiced modding Discord:
	--https://discord.gg/pu2jdxR
	--
	--***Change log***
	--
	--v1.0
	--Changed version to 1.0 to reflect change of author
	--
	--Added selection box to write shadow data to last 44 bytes of file for main car body model
	-- --this enables under shadow and neons for car chassis
	--	
	--v1.1
	--Added cases for certain mesh types and Vertex data structures
	-- --After Market Rims and Exhaust in carmesh.dat now import properly
	--
	--v1.2
	--Added cases for various other certain mesh types and Vertex data structures
	-- --import should now be 99 percent compatible
	--
	--Clean up of script started, UI elements now ordered in appearence from top to bottom
	--Added check box on import for choosing to delete duplicate trifaces
	--
	--Xbox import
	--v1.0
	--Adapted main import script for difference in xbox model files


	on JuicedMeshScript open do
	(
	VisibleDistance = #()
	InvisibleDistance = #()
	--/*
	for i = 1 to 100 do
	(
	VisibleDistance[i] = 0.0 as float
	InvisibleDistance[i] = 1e+006 as float
	)
	--*/
	ListItems = #()
	
	ListItems[1] = "Higest"
	ListItems[2] = "Higher"
	ListItems[3] = "High"
	ListItems[4] = "Medium"
	ListItems[5] = "Low"
	ListItems[6] = "Lower"
	ListItems[7] = "Lowest"
	ListItems[8] = "ber Low"
	ListItems[9] = "Menu - Very High"
	
	ddl1.items = ListItems
	
	ListWidth = #()
	
	ListWidth[1] = "Biggest"
	ListWidth[2] = "Bigger"
	ListWidth[3] = "Big"
	ListWidth[4] = "Medium"
	ListWidth[5] = "Small"
	ListWidth[6] = "Smaller"
	ListWidth[7] = "Smallest"
	
	ddl2.items = ListWidth
	
	ListLength = #()
	
	ListLength[1] = "Biggest"
	ListLength[2] = "Bigger"
	ListLength[3] = "Big"
	ListLength[4] = "Medium"
	ListLength[5] = "Small"
	ListLength[6] = "Smaller"
	ListLength[7] = "Smallest"
	
	ddl3.items = ListLength
		
	)
	on btn2 pressed do
	(
	if chk13.checked == true then
	(
	delete objects
	)
	ClearListener()
	
	f = getOpenFileName \ 
	types:"Juiced bin(*.bin)|*.bin|Juiced d8m(*.d8m)|*.d8m|"
	f = fopen f "rb"
	
	if f != undefined then 
	
	( 
	---------------------------------------------------
	-- Read the total number of indexes in this file --
	---------------------------------------------------
	nTotalIndexes = readlong f
	format "nTotalIndexes: %\n" nTotalIndexes
	Index_Array = #()
	for i = 1 to nTotalIndexes do
	(
	--Read the index into a array
	Index_Array[i] = readshort f
	)
	-----------------------------------------------
	-- Read the number uniqe meshes in this file --
	-----------------------------------------------
	nMeshes = readlong f
	
	for i = 1 to nMeshes do
	(
	-- Read the name of this mesh/texture
	MeshName = readstring f
	
	
	-- These are fixed lenght strings so calcylate the,
	-- number of leftover bytes and read them.
	nBytesLeft = 32 - MeshName.count - 1
	
	for b = 1 to nBytesLeft do
	(
	tmpTrash = readbyte f
	)
	
	if chk1.checked == true then
	(
		StringToAdd = i as string
	
		if i < 10 then
		(
			StringToAdd = "0" + StringToAdd
		)
		StringToAdd = StringToAdd + ","
		append StringToAdd MeshName
		MeshName = StringToAdd
	)
	--setMeditMaterial i MeshName
	--meditMaterials[i].name = meshname
		
	IndexStart = readlong f
	NumberOfIndexes = readlong f
	format "##### -=Mesh=- #####\n"
	format "Name: %\n" MeshName
	format "Index Start Offset: %\n" IndexStart
	format "Number of indexes: %\n" NumberOfIndexes
	
	-- This indicates geometry type e.g. 0,trianglestrip or 1,trianglelist
	GeometryType = readlong f
	format "GeometryType: %\n" GeometryType
	-- See if there are any other values than 0 and 1 here, if so inform user to contact me
	if not GeometryType == 0 and not GeometryType == 1 then
	(
	MessageBox "Not Geometry Type 0 or 1, please contact Carl 'SxnnyB' Burns in Juiced Modding Discord"
	)

	-------------------------------------------------------------------
	-- Now we have come to the part of the file thats mostly unknown --
	-------------------------------------------------------------------
	-- These 44bytes seam to define how the mesh should deform on impact, unknown exactly how
	for u = 1 to 11 do
	(
	Unknown = readfloat f
	format "Value: %\n" Unknown
	)
	-- This is the distance when this mesh becomes visible
	VisibleDistance[i] = readfloat f
	-- This is the distance when this mesh becomes invisible
	InvisibleDistance[i] = readfloat f
	
	format "Visible Distance: %\n" VisibleDistance[i]
	format "Invisible Distance: %\n" InvisibleDistance[i]
	
	-- Unknown what this is if i put 0xff at any place here the model becomes invisible ingame
	-- Seen 0, 1 and 3
	Unknown = readlong f
	format "Unknown Value: %, Meshname: %\n" Unknown MeshName
	if not Unknown == 0 and not Unknown == 1 and not Unknown == 3 then
	(
	messagebox "Found one unknown thats not 0, 1 or 3"
	)
	
	--Read the number of unknown data structures
	NumberOfUnknownStructures = readlong f
	format "NumberOfUnknownStructures : %\n" NumberOfUnknownStructures
	-- These values does not seam to change in the files i have seen
	for u = 1 to NumberOfUnknownStructures do
	(
	Unknown = readshort f
	format "Unknown Structure % Value: %\n" u Unknown
	Unknown = readshort f
	format "Unknown Structure % Value: %\n" u Unknown
	Unknown = readshort f
	format "Unknown Structure % Value: %\n" u Unknown
	Unknown = readshort f
	format "Unknown Structure % Value: %\n" u Unknown
	) 
	-------------------------------------------------------------------
	-- The nBytesPerVertex indicates what data the vertices contain, --
	-- like UV mapping and normals. But also other unknown data.     --
	-------------------------------------------------------------------
	nBytesPerVertex = readlong f
	format "nBytesPerVertex: %\n" nBytesPerVertex
	nVertices = readlong f
	format "nVertices: %\n" nVertices
	format "##### -=EOM=- #####\n"
	
	----------------------------------------------------------------
	-- Now we have come to the point when we read the vertex data --
	----------------------------------------------------------------
	vert_array = #() 
	Vector3D_Array = #() 
	Vertex2D_Array = #()
	
	for v = 1 to nVertices do
		(
		--Vertex
		X = Readfloat f
		Y = Readfloat f
		Z = Readfloat f
	
		vert = [X as float,Z as float,Y as float] as Point3
		vert_array[v] = vert
	
		-- If indicated, read normals and unknown section
	
		if nBytesPerVertex == 32 then
			(
			--Normal
			NX = Readfloat f
			NY = Readfloat f
			NZ = Readfloat f
			Normal = [NX as float,NZ as float,NY as float] as Point3
			Vector3D_Array[v] = Normal
		
			--Unknown section does not exist here
			)
	
		if nBytesPerVertex == 36 then
			(
			--Normal
			NX = Readfloat f
			NY = Readfloat f
			NZ = Readfloat f
			Normal = [NX as float,NZ as float,NY as float] as Point3
			Vector3D_Array[v] = Normal
	
			--Unknown section 
			Unknown = readfloat f
			)
	
			if NumberOfUnknownStructures == 5 and nBytesPerVertex == 40 then
			(
			--Normal
			NX = Readfloat f
			NY = Readfloat f
			NZ = Readfloat f
			Normal = [NX as float,NZ as float,NY as float] as Point3
			Vector3D_Array[v] = Normal
	
			--Unknown section 
			Unknown = readfloat f
			Unknown2 = readfloat f
			)
	
		if nBytesPerVertex == 44 then
			(
			--Normal
			NX = Readfloat f
			NY = Readfloat f
			NZ = Readfloat f
			Normal = [NX as float,NZ as float,NY as float] as Point3
			Vector3D_Array[v] = Normal
	
			--Unknown section 
			Unknown = readfloat f
			)
	
		if nBytesPerVertex == 64 then
			(
			--Normal
			NX = Readfloat f
			NY = Readfloat f
			NZ = Readfloat f
			Normal = [NX as float,NZ as float,NY as float] as Point3
			Vector3D_Array[v] = Normal
				if not MeshName == DRIVER then
				(
				--Unknown section 
				Unknown = readfloat f
				)
			)
	
		if nBytesPerVertex == 24 then
			(	
			--Unknown section 
			Unknown = readfloat f
			)
			
		if not MeshName == DRIVER then
		(
		--UV
		UVW_U = readfloat f
		UVW_V = readfloat f
	
		UVW_W = 0.0 --Fake
		UVW_V = UVW_V - UVW_V - UVW_V
		UV = [UVW_U as float,UVW_V as float,UVW_W as float] as Point3
		Vertex2D_Array[v] = UV
		)

	
	--If indicated read padding
	
	-------------------------------------------------
	-- Unknown what these realy are, just guessed, --
	-- that its a secondary uv channel,            --
	-- only seen zeros here anyway. 			   --
	--								-Martin_SW     --
	--											   --
	-- I assume its Padding after I found files	   --
	-- 64 Bytes per Vertex With padding			   --
	--								-Carl 'SxnnyB  --
	-------------------------------------------------
	
	
	
	if nBytesPerVertex == 44 then
	(
		PadA1 = readfloat f
		PadA2 = readfloat f	
		
		if  MeshName == DRIVER then
			(
			PadA3 = readfloat f
			PadA4 = readfloat f	
			PadA5 = readfloat f
			)
		
	if not PadA1 == 0 then
		(
		messagebox "-PadA1- Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)		
	if not PadA2 == 0 then
		(
		messagebox "-PadA2- Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)
	)
	
	if nBytesPerVertex == 64 then
	(
		PadB1 = readfloat f
		PadB2 = readfloat f
		PadB3 = readfloat f
		PadB4 = readfloat f
		PadB5 = readfloat f
		PadB6 = readfloat f
		PadB7 = readfloat f
	
	if not PadB1 == 0 then
		(
		messagebox "Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)	
	if not PadB2 == 0 then
		(
		messagebox "Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)
	if not PadB3 == 0 then
		(
		messagebox "Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)
	if not PadB4 == 0 then
		(
		messagebox "-Pad B4- Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)
	if not PadB5 == 0 then
		(
		messagebox "-Pad B5- Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)
	if not PadB6 == 0 then
		(
		messagebox "-Pad B6- Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)
	if not PadB7 == 0 then
		(
		messagebox "-Pad B7- Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)	
	)
	
	)
		
	--------------------------------------------------
	-- Now that we have read this mesh we must,     --
	-- destrip it to create a triangle list insted, --
	-- of a triangle strip.                         --
	--------------------------------------------------	
	
	if GeometryType == 0 then
		(
		Face_Array = #() 
		FaceUV_Array = #() 
		Flag = 0
		counter = 1
		for t = 1 to NumberOfIndexes - 2 do
			(
			AddTriangle = 1
	
			if Flag == 1 then
				(
				Flag = 0
				Index1 = Index_Array[IndexStart + t]
				Index2 = Index_Array[IndexStart + t + 1]
				Index3 = Index_Array[IndexStart + t + 2]
				)
			else
				(
				Flag = 1
				Index3 = Index_Array[IndexStart + t]
				Index2 = Index_Array[IndexStart + t + 1]
				Index1 = Index_Array[IndexStart + t + 2]
				)
	
			Index1 = Index1 + 1
			Index2 = Index2 + 1
			Index3 = Index3 + 1
			
	--Check if any of the indexes in the triangle is repeated if so don't add the triangle
	
		if chk14.checked == true then
			(
			if Index1 == Index2 then
				(
				AddTriangle = 0
				)
			if Index1 == Index3 then
				(
				AddTriangle = 0
				)
			if Index2 == Index1 then
				(
				AddTriangle = 0
				)
			if Index2 == Index3 then
				(
				AddTriangle = 0
				)
			if Index3 == Index1 then
				(
				AddTriangle = 0
				)
			if Index3 == Index2 then
				(
				AddTriangle = 0
				)
	
			if AddTriangle == 1 then
				(
				TriFace = [Index1,Index2,Index3] as Point3
				Face_Array[counter] = TriFace
	
				TriFace2 = [Index1,Index2,Index3] as Point3
				FaceUV_Array[counter] = TriFace2
				counter = counter + 1
				)
			)
			
		if not chk14.checked == true then
			(
			if AddTriangle == 1 then
				(
				TriFace = [Index1,Index2,Index3] as Point3
				Face_Array[counter] = TriFace
	
				TriFace2 = [Index1,Index2,Index3] as Point3
				FaceUV_Array[counter] = TriFace2
				counter = counter + 1
				)
			)		
		)
	)
	
	if GeometryType == 1 then
	(
	-- If the GeometryType indicates this mesh is made up by a trianglelist,
	-- insted of a trianglestrip then interpet it as a trianglelist.
	Face_Array = #() 
	FaceUV_Array = #()
	counter = 1
	for t = 1 to NumberOfIndexes / 3 do
	(
	Index3 = Index_Array[IndexStart + ((t - 1) * 3) + 1]
	Index2 = Index_Array[IndexStart + ((t - 1) * 3) + 2]
	Index1 = Index_Array[IndexStart + ((t - 1) * 3) + 3]

	
	Index1 = Index1 + 1
	Index2 = Index2 + 1
	Index3 = Index3 + 1
	
	TriFace = [Index1,Index2,Index3] as Point3
	Face_Array[counter] = TriFace
	
	TriFace2 = [Index1,Index2,Index3] as Point3
	FaceUV_Array[counter] = TriFace2
	counter = counter + 1
	)
	)
	
	tmpMesh = mesh name:MeshName vertices:vert_array faces:Face_Array-- normals:Vector3D_Array
	
	
	--tmpMesh.material = MeshName
	--Apply things like normals and uv mapping
	mesh_uv_vert = nVertices 
	
	setNumTVerts tmpMesh nVertices 
	buildTVFaces tmpMesh
	
	--Fill corrdinate list
	for uv = 1 to mesh_uv_vert do
	(
	--Fill the list whit uv corrds for usage later when attaching them to a face
	
	setTVert tmpMesh uv Vertex2D_Array[uv]
	buildTVFaces tmpMesh
	)
	--Attatc to a face
	for uv = 1 to counter - 1 do
	(
	
	TriFace = FaceUV_Array[uv]
	
	TriFace = TriFace as Point3
	setTVFace tmpMesh uv TriFace
	--buildTVFaces tmpMesh
	)
	
	
	--rotate tmpMesh (angleaxis -90 [1,0,0])
	--rotate tmpMesh (angleaxis 180 [0,1,0])
	
	)
	----------------------------------------------------------
	-- These last 44bytes of the files defines the shadow,  --
	-- the exact way it does this is currently not          --
	-- known, it seams to use a set of float values and     --
	-- then use them to build the shadow in a specific way. --
	----------------------------------------------------------
	vert_array = #()
	Face_Array = #()
	for v = 1 to 11 do
	(
	--Vertex
	--X = Readfloat f
	--Y = Readfloat f
	--Z = Readfloat f
	
	--vert = [X as float,Z as float,Y as float] as Point3
	--vert_array[v] = vert
	Unknown = readfloat f
	format "Unknown Value %: %\n" v Unknown
	)
	--for f = 1 to 2 do
	--(
	--Index1 = f
	--Index2 = f + 1
	--Index3 = f + 2
	--TriFace = [Index1,Index2,Index3] as Point3
	--Face_Array[f] = TriFace
	--)
	--tmpMesh = mesh name:"SHADOW" vertices:vert_array faces:Face_Array
	fclose f
	)-- If to read
	
	

	)
	
	
	on lbx1 selected sel do
	(
	if VisibleDistance[lbx1.selection] == 0 then
	(
	LOD = 1
	)
	if VisibleDistance[lbx1.selection] == 1e+006 then
	(
	LOD = 2
	)
	if VisibleDistance[lbx1.selection] == 4e+006 then
	(
	LOD = 3
	)
	if VisibleDistance[lbx1.selection] == 9e+006 then
	(
	LOD = 4
	)
	if VisibleDistance[lbx1.selection] == 2.5e+007 then
	(
	LOD = 5
	)
	if VisibleDistance[lbx1.selection] == 1e+008 then
	(
	LOD = 6
	)
	if VisibleDistance[lbx1.selection] == 1e+012 then
	(
	LOD = 7
	)
	if VisibleDistance[lbx1.selection] == 4e+012 then
	(
	LOD = 8
	)
	if InvisibleDistance[lbx1.selection] == 3.40282e+038 then
	(
	LOD = 9
	)
	if LOD == undefined then
	(
	format "Vis: %, Invis: %\n" VisibleDistance[lbx1.selection] InvisibleDistance[lbx1.selection]
	messagebox "Prepare for crash, sorry :)"
	)
	ddl1.selection = LOD
	)
	on ddl1 selected sel do
	(
	if ddl1.selection == 1 then
	(
	VisDist = 0 as float
	InvisDist = 1e+006 as float
	)
	if ddl1.selection == 2 then
	(
	VisDist = 1e+006 as float
	InvisDist = 4e+006 as float
	)
	if ddl1.selection == 3 then
	(
	VisDist = 4e+006 as float
	InvisDist = 9e+006 as float
	)
	if ddl1.selection == 4 then
	(
	VisDist = 9e+006 as float
	InvisDist = 2.5e+007 as float
	)
	if ddl1.selection == 5 then
	(
	VisDist = 2.5e+007 as float
	InvisDist = 1e+008 as float
	)
	if ddl1.selection == 6 then
	(
	VisDist = 1e+008 as float
	InvisDist = 1e+012 as float
	)
	if ddl1.selection == 7 then
	(
	VisDist = 1e+012 as float
	InvisDist = 4e+012 as float
	)
	if ddl1.selection == 8 then
	(
	VisDist = 4e+012 as float
	InvisDist = 9e+012 as float
	)
	if ddl1.selection == 9 then
	(
	VisDist = 0 as float
	InvisDist = 3.40282e+038 as float
	)
	
	VisibleDistance[lbx1.selection] = VisDist as float
	InvisibleDistance[lbx1.selection] = InvisDist as float
	format "LOD % Set\n" ddl1.selection
	
	)
	on btn6 pressed do
	(
	/*
	if ($selection.count == 0 ) then 
	( 
	messagebox "No object selected.\nPlease select a Geometry Object first.\n" 
	return 0
	) 
	*/
	ClearListener()
	f = getSaveFileName caption:"Juiced Car Geometry Export" types:"Juiced bin(*.bin)|*.bin|Juiced d8m(*.d8m)|*.d8m|"
	
	--out_name = fname
	--out_file = createfile out_name 
	
	f = fopen f "wb"
	nTotalIndexes = 0
	if f != undefined then 
	(
	Index_Array = #()
	IndexStart = #()
	NumberOfIndexes = #()
	Names = #()
	counter = 1
	nMeshes = selection.count
	for m = 1 to nMeshes do
	(
	--Create a snapshot of the selected mesh
	tmesh = snapshotAsMesh selection[m] 
	
	-----------------------------------------------------------
	-- The Stripper function :), it converts triangle lists, --
	-- into triangle strips                                  --
	-----------------------------------------------------------
	num_faces = tmesh.numfaces
	tmpFaceVertexIndex = #()
	--Get Face from object
	for t = 1 to num_faces do
	(
		FaceVertices = getFace tmesh t
		tmpValue = FaceVertices as string
		tmpFaceVertexIndex[t] = filterString tmpValue "[ ] ,"
	)
	
	IndexStart[m] = counter - 1
	--Face Data
	tmpFaceIndex1 = tmpFaceVertexIndex[1][1]
	tmpFaceIndex2 = tmpFaceVertexIndex[1][2]
	tmpFaceIndex3 = tmpFaceVertexIndex[1][3]
	--Vertex
	Index1 = tmpFaceIndex1 as integer
	Index1 = Index1 - 1
	Index2 = tmpFaceIndex2 as integer
	Index2 = Index2 - 1
	Index3 = tmpFaceIndex3 as integer
	Index3 = Index3 - 1
	
	counter_before = counter - 1
	
	Index_Array[counter] = Index3
	counter = counter + 1
	Index_Array[counter] = Index2
	counter = counter + 1
	Index_Array[counter] = Index1
	counter = counter + 1
	Index_Array[counter] = Index1
	counter = counter + 1
	
	for t = 2 to num_faces do
	(
	--Face Data
	tmpFaceIndex1 = tmpFaceVertexIndex[t][1]
	tmpFaceIndex2 = tmpFaceVertexIndex[t][2]
	tmpFaceIndex3 = tmpFaceVertexIndex[t][3]
	
	--Vertex
	Index1 = tmpFaceIndex1 as integer
	Index1 = Index1 - 1
	Index2 = tmpFaceIndex2 as integer
	Index2 = Index2 - 1
	Index3 = tmpFaceIndex3 as integer
	Index3 = Index3 - 1
	
	Index_Array[counter] = Index3
	counter = counter + 1
	Index_Array[counter] = Index3
	counter = counter + 1
	Index_Array[counter] = Index3
	counter = counter + 1
	Index_Array[counter] = Index2
	counter = counter + 1
	Index_Array[counter] = Index1
	counter = counter + 1
	Index_Array[counter] = Index1
	counter = counter + 1
	
	)
	format "Indexes: %\n" (counter - 2)
	NumberOfIndexes[m] = (counter - 1) - counter_before - 1
	)
	counter = counter - 1
	-- Now that the ber bad stripper has stripped the data, write it to file
	num_indexex = counter - 1
	writelong f num_indexex
	for i = 1 to num_indexex do
	(
	writeshort f Index_Array[i]
	)
	-- Write nMeshes
	writelong f nMeshes
	for m = 1 to nMeshes do
	(
	-- Write this mesh's name to file
	MeshName = selection[m].name
	
	Names[1] = filterString MeshName ","
	
	MeshName = Names[1][2]
	
	
	writestring f MeshName
	CharLeft = 32 - MeshName.count - 1
	for i = 1 to CharLeft do
	(
	writebyte f 0
	)
	writelong f IndexStart[m]
	writelong f NumberOfIndexes[m]
	format "IndexStart: %\n" IndexStart[m]
	format "NumberOfIndexes: %\n" NumberOfIndexes[m]
	-------------------------------------------------------------------
	-- Now we have come to the part of the file thats mostly unknown --
	-------------------------------------------------------------------
	-- This indicates if this mesh is made up by a 0,trianglestrip or a 1,trianglelist
	writelong f 0
	-- Seams to define how the mesh should deform on impact, unkown exaclty how
	-- For now, write zeros here. note, this makes the mesh not deform on impact
	for u = 1 to 11 do
	(
	writefloat f 0
	)
	-- This makes the mesh visible at the specified distance
	writefloat f VisibleDistance[m]
	-- Makes the mesh invisible at this distance
	writefloat f InvisibleDistance[m]
	-- Write a unknown value, 0 works, seen 0, 1 and 3, 1 and 3 makes the mesh invisible ingame
	writelong f 0
	-- The number of unknown data structures in this file,
	-- this is needed but not mapped so use values from a other file 
	writelong f 5
	-- Put some data here just to make it work
	writeshort f 0
	writeshort f 0
	writeshort f 2
	writeshort f 0
	writeshort f 0
	writeshort f 12
	writeshort f 2
	writeshort f 3
	writeshort f 0
	writeshort f 24
	writeshort f 4
	writeshort f 10
	writeshort f 0
	writeshort f 28
	writeshort f 1
	writeshort f 5
	writeshort f 255
	writeshort f 0
	writeshort f 17
	writeshort f 0
	-- Now write the bytes per vertex
	writelong f 36
	-- Number of vertices
	tmesh = snapshotAsMesh selection[m] 
	num_verts = tmesh.numverts 
	format "Num verts: %\n" num_verts
	writelong f num_verts
	
	tmpVertices = #()
	tmpNormals = #()
	tmpUV = #()
	tmpFaceVertexIndex = #()
	tmpArr5 = #()
	tmpArr6 = #()
	tmpArr7 = #()
	tmpArr8 = #()
	tmpArr9 = #()
	tmpArr10 = #()
	tmpNorm = #()
	tmpNormArray = #()
	
	for v = 1 to num_verts do
	(
	  	Vertex = getVert tmesh v 
		tmpValue = Vertex as string
		tmpVertices[v] = filterString tmpValue "[ ] ,"
		X = tmpVertices[v][1] as float
		Y = tmpVertices[v][2] as float
		Z = tmpVertices[v][3] as float
		writefloat f X
		writefloat f Z
		writefloat f Y
	
		Normal = getNormal tmesh v
		tmpValue = Normal as string
		tmpNormals[v] = filterString tmpValue "[ ] ,"
		NX = tmpNormals[v][1] as float
		NY = tmpNormals[v][2] as float
		NZ = tmpNormals[v][3] as float
		writefloat f NX
		writefloat f NZ
		writefloat f NY
		
		--Color?
		writelong f 0
	
	
		UV = getTVert tmesh v
		tmpValue = UV as string
		tmpUV[v] = filterString tmpValue "[ ] ,"
		U = tmpUV[v][1] as float
		V = tmpUV[v][2] as float
		--Invert V
		V = V - V - V
		writefloat f U
		writefloat f V
	
	
	)
	)
	-- The way this game defines shadows is currently not known, so for now, NO shadow at all	
	
	
	if chk13.checked == true then
	(
	writeshort f 19232
	writeshort f 49360
	writeshort f 4317
	writeshort f 17031
	writeshort f 52881
	writeshort f 16778
	writeshort f 0
	writeshort f 0
	writeshort f 26667
	writeshort f 17278
	writeshort f 63831
	writeshort f 49866
	writeshort f 43613
	writeshort f 16747
	writeshort f 52904
	writeshort f 49995
	writeshort f 63831
	writeshort f 17098
	writeshort f 58100
	writeshort f 17142
	writeshort f 17038
	writeshort f 17221
	)
	
	if chk13.checked == false then
	(
	for u = 1 to 11 do
	(
	writefloat f 0
	)
	)
	
	
	
	
	) -- If to write
	
	fclose f
	
	)
	on btn27 pressed do
	(
	Object = #()
	Names = #()
	MeshIndex = #()
	nMeshesToExport = selection.count
	for i = 1 to nMeshesToExport do
	(
	MeshName = selection[i].name
	
	Names[1] = filterString MeshName ","
	
	MeshName = Names[1][2]
	Object[i] = MeshName
	MeshIndex[i] = i
	)
	lbx1.items = Object
	)
)