utility JuicedMeshScript "Juiced 2020 v1.0 XBOX" width:160 height:466
(
	global VisibleDistance
	global InvisibleDistance
	GroupBox grp1 "Juiced Mesh Importer" pos:[0,0] width:160 height:120
	checkbox chk1 "Index Objects" pos:[8,16] width:144 height:16 enabled:true checked:true
	checkbox chk13 "Clear Scene" pos:[8,40] width:128 height:15 checked:true
	checkbox chk14 "Delete Duplicate TriFaces" pos:[8,65] width:145 height:15 checked:true
	button btn3 "Import Xbox" pos:[40,90] width:80 height:24
	
	--Original Juiced Import Script
	--Version 0.2
	--Made By: Martin_sw
	--
	--Juiced Import Script
	--Version 1.0 - 1.3
	--Made By: Carl 'SxynnyB' Burns
	--
	--Juiced Xbox Import Script
	--Version 1.0
	--Made By: Carl 'SxynnyB' Burns
	--
	--Juiced modding Discord:
	--https://discord.gg/pu2jdxR
	--
	--***Change log***
	--
	--v1.0
	--Changed version to 1.0 to reflect change of author
	--
	--Added selection box to write shadow data to last 44 bytes of file for main car body model
	-- --this enables under shadow and neons for car chassis
	--	
	--v1.1
	--Added cases for certain mesh types and Vertex data structures
	-- --After Market Rims and Exhaust in carmesh.dat now import properly
	--
	--v1.2
	--Added cases for various other certain mesh types and Vertex data structures
	-- --import should now be 99 percent compatible
	--
	--Clean up of script started, UI elements now ordered in appearence from top to bottom
	--Added check box on import for choosing to delete duplicate trifaces
	--
	--Xbox import
	--v1.0
	--Adapted main import script for difference in xbox model files
	
	on JuicedMeshScript open do
	(
	VisibleDistance = #()
	InvisibleDistance = #()
	--/*
	for i = 1 to 100 do
	(
	VisibleDistance[i] = 0.0 as float
	InvisibleDistance[i] = 1e+006 as float
	)		
	)
	
	on btn3 pressed do
	(	
	if chk13.checked == true then
	(
	delete objects
	)
	ClearListener()
	
	f = getOpenFileName \ 
	types:"Juiced bin(*.bin)|*.bin|"
	f = fopen f "rb"
	
	if f != undefined then 
	
	( 
	---------------------------------------------------
	-- Read the total number of indexes in this file --
	---------------------------------------------------
	nTotalIndexes = readlong f
	format "nTotalIndexes: %\n" nTotalIndexes
	Index_Array = #()
	for i = 1 to nTotalIndexes do
	(
	--Read the index into a array
	Index_Array[i] = readshort f
	)
	-----------------------------------------------
	-- Read the number uniqe meshes in this file --
	-----------------------------------------------
	nMeshes = readlong f
	
	for i = 1 to nMeshes do
	(
	-- Read the name of this mesh/texture
	MeshName = readstring f
	
	
	-- These are fixed lenght strings so calcylate the,
	-- number of leftover bytes and read them.
	nBytesLeft = 32 - MeshName.count - 1
	
	for b = 1 to nBytesLeft do
	(
	tmpTrash = readbyte f
	)
	
	if chk1.checked == true then
	(
		StringToAdd = i as string
	
		if i < 10 then
		(
			StringToAdd = "0" + StringToAdd
		)
		StringToAdd = StringToAdd + ","
		append StringToAdd MeshName
		MeshName = StringToAdd
	)
	--setMeditMaterial i MeshName
	--meditMaterials[i].name = meshname
		
	IndexStart = readlong f
	NumberOfIndexes = readlong f
	format "##### -=Mesh=- #####\n"
	format "Name: %\n" MeshName
	format "Index Start Offset: %\n" IndexStart
	format "Number of indexes: %\n" NumberOfIndexes
	
	-- This indicates geometry type e.g. 0,trianglestrip or 1,trianglelist
	GeometryType = readlong f
	format "GeometryType: %\n" GeometryType
	-- See if there are any other values than 0 and 1 here, if so inform user to contact me
	if not GeometryType == 0 and not GeometryType == 1 then
	(
	MessageBox "Not Geometry Type 0 or 1, please contact Carl 'SxnnyB' Burns in Juiced Modding Discord"
	)

	-------------------------------------------------------------------
	-- Now we have come to the part of the file thats mostly unknown --
	-------------------------------------------------------------------
	-- These 44bytes seam to define how the mesh should deform on impact, unknown exactly how
	for u = 1 to 11 do
	(
	Unknown = readfloat f
	format "Value: %\n" Unknown
	)
	
	-- This is the distance when this mesh becomes visible
	VisibleDistance[i] = readfloat f
	
	-- This is the distance when this mesh becomes invisible
	InvisibleDistance[i] = readfloat f
	
	format "Visible Distance: %\n" VisibleDistance[i]
	format "Invisible Distance: %\n" InvisibleDistance[i]
	
	--read unknowns 1,2 and 3	
	
	Unknown1 = readlong f
	format "Unknown1 Value: %, Meshname: %\n" Unknown1 MeshName
	if not Unknown1 == 0 and not Unknown1 == 1 and not Unknown1 == 3 then
	(
	messagebox "Found one unknown1 thats not 0,1 or 3"
	)
	
		Unknown2 = readlong f
	format "Unknown2 Value: %, Meshname: %\n" Unknown2 MeshName
	if not Unknown2 == 0 then
	(
	messagebox "Found one unknown2 thats not 0"
	)
	
		Unknown3 = readlong f
	format "Unknown3 Value: %, Meshname: %\n" Unknown3 MeshName
	if not Unknown3 == 0 then
	(
	messagebox "Found one unknown3 thats not 0"
	)
	
	
	--Read the number of unknown data structures
	
	NUStructures = readlong f
	format "NUStructures : %\n" NUStructures
	
	if not NUStructures == 50 then
	(
	messagebox "Found one NUStructures thats not 50"
	)
	
	for u = 1 to 61 do
	(
	Unknown = readfloat f
	) 
	-------------------------------------------------------------------
	-- The nBytesPerVertex indicates what data the vertices contain, --
	-- like UV mapping and normals. But also other unknown data.     --
	-------------------------------------------------------------------
	nBytesPerVertex = readlong f
	format "nBytesPerVertex: %\n" nBytesPerVertex
	nVertices = readlong f
	format "nVertices: %\n" nVertices
	format "##### -=EOM=- #####\n"
	
	----------------------------------------------------------------
	-- Now we have come to the point when we read the vertex data --
	----------------------------------------------------------------
	vert_array = #() 
	Vector3D_Array = #() 
	Vertex2D_Array = #()
	
	for v = 1 to nVertices do
		(
		--Vertex
		X = Readfloat f
		Y = Readfloat f
		Z = Readfloat f
	
		vert = [X as float,Z as float,Y as float] as Point3
		vert_array[v] = vert
				
		-- If indicated, read normals and unknown section
	
		if nBytesPerVertex == 32 then
			(
			--Normal
			NX = Readfloat f
			NY = Readfloat f
			NZ = Readfloat f
			Normal = [NX as float,NZ as float,NY as float] as Point3
			Vector3D_Array[v] = Normal
		
			--Unknown section does not exist here
			)
	
		if nBytesPerVertex == 36 then
			(
			--Normal
			NX = Readfloat f
			NY = Readfloat f
			NZ = Readfloat f
			Normal = [NX as float,NZ as float,NY as float] as Point3
			Vector3D_Array[v] = Normal
	
			--Unknown section 
			Unknown = readfloat f
			)
	
			if NumberOfUnknownStructures == 5 and nBytesPerVertex == 40 then
			(
			--Normal
			NX = Readfloat f
			NY = Readfloat f
			NZ = Readfloat f
			Normal = [NX as float,NZ as float,NY as float] as Point3
			Vector3D_Array[v] = Normal
	
			--Unknown section 
			Unknown = readfloat f
			Unknown2 = readfloat f
			)
	
		if nBytesPerVertex == 44 then
			(
			--Normal
			NX = Readfloat f
			NY = Readfloat f
			NZ = Readfloat f
			Normal = [NX as float,NZ as float,NY as float] as Point3
			Vector3D_Array[v] = Normal
	
			--Unknown section 
			Unknown = readfloat f
			)
	
		if nBytesPerVertex == 64 then
			(
			--Normal
			NX = Readfloat f
			NY = Readfloat f
			NZ = Readfloat f
			Normal = [NX as float,NZ as float,NY as float] as Point3
			Vector3D_Array[v] = Normal
				if not MeshName == DRIVER then
				(
				--Unknown section 
				Unknown = readfloat f
				)
			)
	
		if nBytesPerVertex == 24 then
			(	
			--Unknown section 
			Unknown = readfloat f
			)
			
		if not MeshName == DRIVER and not nBytesPerVertex == 16 then
		(			
			--UV
			UVW_U = readfloat f
			UVW_V = readfloat f
	
			UVW_W = 0.0 --Fake
			UVW_V = UVW_V - UVW_V - UVW_V
			UV = [UVW_U as float,UVW_V as float,UVW_W as float] as Point3
			Vertex2D_Array[v] = UV			
		)

	
	--If indicated read padding
	
	-------------------------------------------------
	-- Unknown what these realy are, just guessed, --
	-- that its a secondary uv channel,            --
	-- only seen zeros here anyway. 			   --
	--								-Martin_SW     --
	--											   --
	-- I assume its Padding after I found files	   --
	-- 64 Bytes per Vertex With padding			   --
	--								-Carl 'SxnnyB  --
	-------------------------------------------------
	
	
	
	if nBytesPerVertex == 44 then
	(
		PadA1 = readfloat f
		PadA2 = readfloat f	
		
		if  MeshName == DRIVER then
			(
			PadA3 = readfloat f
			PadA4 = readfloat f	
			PadA5 = readfloat f
			)
		
	if not PadA1 == 0 then
		(
		messagebox "-PadA1- Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)		
	if not PadA2 == 0 then
		(
		messagebox "-PadA2- Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)
	)
	
	if nBytesPerVertex == 64 then
	(
		PadB1 = readfloat f
		PadB2 = readfloat f
		PadB3 = readfloat f
		PadB4 = readfloat f
		PadB5 = readfloat f
		PadB6 = readfloat f
		PadB7 = readfloat f
	
	if not PadB1 == 0 then
		(
		messagebox "Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)	
	if not PadB2 == 0 then
		(
		messagebox "Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)
	if not PadB3 == 0 then
		(
		messagebox "Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)
	if not PadB4 == 0 then
		(
		messagebox "-Pad B4- Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)
	if not PadB5 == 0 then
		(
		messagebox "-Pad B5- Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)
	if not PadB6 == 0 then
		(
		messagebox "-Pad B6- Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)
	if not PadB7 == 0 then
		(
		messagebox "-Pad B7- Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)	
	)
	
	if nBytesPerVertex == 16 then
	(
			PadC1 = readfloat f

		
	if not PadC1 == 0 then
		(
		messagebox "-PadC1- Please contact Carl 'SxnnyB' Burns with info on filenumber and archive name."
		)		
	)
	
	)
		
	--------------------------------------------------
	-- Now that we have read this mesh we must,     --
	-- destrip it to create a triangle list insted, --
	-- of a triangle strip.                         --
	--------------------------------------------------	
	
	if GeometryType == 0 then
		(
			if not nBytesPerVertex == 16 then 
				(
				Face_Array = #() 
				FaceUV_Array = #() 
				Flag = 0
				counter = 1
				for t = 1 to NumberOfIndexes - 2 do
					(
					AddTriangle = 1
	
						if Flag == 1 then
							(
							Flag = 0
							Index1 = Index_Array[IndexStart + t]
							Index2 = Index_Array[IndexStart + t + 1]
							Index3 = Index_Array[IndexStart + t + 2]
							)
						else
							(
							Flag = 1
							Index3 = Index_Array[IndexStart + t]
							Index2 = Index_Array[IndexStart + t + 1]
							Index1 = Index_Array[IndexStart + t + 2]
							)
	
					Index1 = Index1 + 1
					Index2 = Index2 + 1
					Index3 = Index3 + 1
			
	--Check if any of the indexes in the triangle is repeated if so don't add the triangle
	
		if chk14.checked == true then
			(
			if Index1 == Index2 then
				(
				AddTriangle = 0
				)
			if Index1 == Index3 then
				(
				AddTriangle = 0
				)
			if Index2 == Index1 then
				(
				AddTriangle = 0
				)
			if Index2 == Index3 then
				(
				AddTriangle = 0
				)
			if Index3 == Index1 then
				(
				AddTriangle = 0
				)
			if Index3 == Index2 then
				(
				AddTriangle = 0
				)
	
			if AddTriangle == 1 then
				(
				TriFace = [Index1,Index2,Index3] as Point3
				Face_Array[counter] = TriFace
	
				TriFace2 = [Index1,Index2,Index3] as Point3
				FaceUV_Array[counter] = TriFace2
				counter = counter + 1
				)
			)
			
		if not chk14.checked == true then
			(
			if AddTriangle == 1 then
				(
				TriFace = [Index1,Index2,Index3] as Point3
				Face_Array[counter] = TriFace
	
				TriFace2 = [Index1,Index2,Index3] as Point3
				FaceUV_Array[counter] = TriFace2
				counter = counter + 1
				)
				)
			)		
		)
		
		if nBytesPerVertex == 16 then 
				(
				Face_Array = #() 
				Flag = 0
				counter = 1
				for t = 1 to NumberOfIndexes - 2 do
					(
					AddTriangle = 1
	
						if Flag == 1 then
							(
							Flag = 0
							Index1 = Index_Array[IndexStart + t]
							Index2 = Index_Array[IndexStart + t + 1]
							Index3 = Index_Array[IndexStart + t + 2]
							)
						else
							(
							Flag = 1
							Index3 = Index_Array[IndexStart + t]
							Index2 = Index_Array[IndexStart + t + 1]
							Index1 = Index_Array[IndexStart + t + 2]
							)
	
					Index1 = Index1 + 1
					Index2 = Index2 + 1
					Index3 = Index3 + 1
			
	--Check if any of the indexes in the triangle is repeated if so don't add the triangle
	
		if chk14.checked == true then
			(
			if Index1 == Index2 then
				(
				AddTriangle = 0
				)
			if Index1 == Index3 then
				(
				AddTriangle = 0
				)
			if Index2 == Index1 then
				(
				AddTriangle = 0
				)
			if Index2 == Index3 then
				(
				AddTriangle = 0
				)
			if Index3 == Index1 then
				(
				AddTriangle = 0
				)
			if Index3 == Index2 then
				(
				AddTriangle = 0
				)
	
			if AddTriangle == 1 then
				(
				TriFace = [Index1,Index2,Index3] as Point3
				Face_Array[counter] = TriFace
				counter = counter + 1
				)
			)
			
		if not chk14.checked == true then
			(
			if AddTriangle == 1 then
				(
				TriFace = [Index1,Index2,Index3] as Point3
				Face_Array[counter] = TriFace
				counter = counter + 1
				)
				)
			)		
		)
		
	)
	
	
	if GeometryType == 1 then
	(
	-- If the GeometryType indicates this mesh is made up by a trianglelist,
	-- insted of a trianglestrip then interpet it as a trianglelist.
	Face_Array = #() 
	FaceUV_Array = #()
	counter = 1
	for t = 1 to NumberOfIndexes / 3 do
	(
	Index3 = Index_Array[IndexStart + ((t - 1) * 3) + 1]
	Index2 = Index_Array[IndexStart + ((t - 1) * 3) + 2]
	Index1 = Index_Array[IndexStart + ((t - 1) * 3) + 3]

	
	Index1 = Index1 + 1
	Index2 = Index2 + 1
	Index3 = Index3 + 1
	
	TriFace = [Index1,Index2,Index3] as Point3
	Face_Array[counter] = TriFace
	
	TriFace2 = [Index1,Index2,Index3] as Point3
	FaceUV_Array[counter] = TriFace2
	counter = counter + 1
	)
	)
	
	tmpMesh = mesh name:MeshName vertices:vert_array faces:Face_Array-- normals:Vector3D_Array
	
	
	--tmpMesh.material = MeshName
	--Apply things like normals and uv mapping
	mesh_uv_vert = nVertices 
	
	setNumTVerts tmpMesh nVertices 
	buildTVFaces tmpMesh
	
	--Fill corrdinate list
	for uv = 1 to mesh_uv_vert do
	(
	--Fill the list whit uv corrds for usage later when attaching them to a face
	
	setTVert tmpMesh uv Vertex2D_Array[uv]
	buildTVFaces tmpMesh
	)
	--Attatc to a face
	for uv = 1 to counter - 1 do
	(
	
	TriFace = FaceUV_Array[uv]
	
	TriFace = TriFace as Point3
	setTVFace tmpMesh uv TriFace
	--buildTVFaces tmpMesh
	)
	
	
	--rotate tmpMesh (angleaxis -90 [1,0,0])
	--rotate tmpMesh (angleaxis 180 [0,1,0])
	
	)
	----------------------------------------------------------
	-- These last 44bytes of the files defines the shadow,  --
	-- the exact way it does this is currently not          --
	-- known, it seams to use a set of float values and     --
	-- then use them to build the shadow in a specific way. --
	----------------------------------------------------------
	vert_array = #()
	Face_Array = #()
	for v = 1 to 11 do
	(
	--Vertex
	--X = Readfloat f
	--Y = Readfloat f
	--Z = Readfloat f
	
	--vert = [X as float,Z as float,Y as float] as Point3
	--vert_array[v] = vert
	Unknown = readfloat f
	format "Unknown Value %: %\n" v Unknown
	)
	--for f = 1 to 2 do
	--(
	--Index1 = f
	--Index2 = f + 1
	--Index3 = f + 2
	--TriFace = [Index1,Index2,Index3] as Point3
	--Face_Array[f] = TriFace
	--)
	--tmpMesh = mesh name:"SHADOW" vertices:vert_array faces:Face_Array
	fclose f
	)
	)
	)